// CalculatorPage.cpp : implementation file
//

#include "stdafx.h"
#include "CalculatorPage.h"
#include "YtvEditGridDial.h"
#include "YtvInvalidCommandDial.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCalculatorPage property page
/////////////// auxFormulas
 double SfFromAConst(double A_C);
 double SfFromAcd(double ACD);
 double AcdFromSF(double SF);
 double AConstFromSF(double SF);
 double SrkACDFromAConst(double A_Const);
///////////////////////////////////////
///////// METHOD1Formulas
 void PersAcdMETHOD1Formula(double P,double Rx,double A,double K,double* pACD,unsigned int* n);
 void QMETHOD1Formula(double* ACD,double A,double K,double pACD);
 void METHOD1IOLPowerFormula(double* P,double AL,double K,double ACD,double Rx);
 void METHOD1RetrErrFormula(double P,double A,double K,double C,double *Rx);
 void METHOD1AxialLengthFormula(double P,double* A,double K,double C,double R);
///////// METHOD0Formulas
 void METHOD0FormulaForwardIOLSol(double* I,double Ref,double AL,double K,double SF,double V=12);
 void METHOD0FormulaForwardRefSol(double I,double* Ref,double AL,double K,double SF,double V/*=12*/);
 void METHOD0FormulaReverseSFSol(double I,double ARef,double AL,double K,double* SF,double V/*=12*/);
//////// Srk_tFormulas
 void Srk_tEmmetrAmetrFormulaIOL(double*IOL,double REFR,double AL,double K1D,double K2D,double IOLACD);
 void Srk_tEmmetrAmetrFormulaREFR(double IOL,double* REFR,double AL,double K1D,double K2D,double IOLACD);
 void Srk_tCalc(double KD,double AL,double IOLACD,double Rx);
 void Srk_tCalc(double* PEmmetrpNew,double KD,double AL,double IOLACD,double Rx);
 void Srk_tGetA_Const(double* pA_Const, double IOL, double AL,double Ref,double K);
///////////////////////////
char g_lpApplicationName[]="c:\\Windows\\Explorer.exe";
BOOL g_bCalculatePageInited=FALSE;
extern DWORD g_uWM_YTV_EditGrid;//=RegisterWindowMessage((const char *)g_szWM_YTV_EditGrid);
extern int g_nCataract;
extern CString g_strCatAvAlDistOD;
extern CString g_strCatAvAlDistOS;
extern CString g_strAphAvAlDistOD;
extern CString g_strAphAvAlDistOS;
extern CString g_strDistOS;
extern CString g_strDistOD;
CString g_strCatSDAlDistOD="";
CString g_strCatSDAlDistOS="";
CString g_strAphSDAlDistOD="";
CString g_strAphSDAlDistOS="";
extern BOOL g_bOD;
extern int g_nRow;
extern CString g_szPatientId;
extern int g_nMETHOD1Calc;
entypeRegistryNodes CCalculatorPage::m_enTypeRegNode=encFullLensTypeRec;
char* CCalculatorPage::m_pszPatientRecFormat[]={"PatientID","FirstName","LastName","DoctorName", "Nt",NULL};
char* CCalculatorPage::m_pszDoctorRecFormat[]={"OficeName","OficeAddress","DoctorID","FirstName","LastName",NULL};
char* CCalculatorPage::m_pszFullPatientRecFormat[]={"PatientID","FirstName","LastName","DoctorName", "Nt","DoctorID","DateOfBirth","Sex","Address","City","State","Zip","Phone","RiK1V","RiK2V","RiKV","LeK1V","LeK2V","LeKV","RiDist","LeDist","RiCatAvAl","RiCatSD","RiAphAvAl","RiAphSD","LeCatAvAl","LeCatSD","LeAphAvAl","LeAphSD",NULL};
char* CCalculatorPage::m_pszFullDoctorRecFormat[]={"DoctorID","FirstName","LastName","Nt","OficeName","OficeAddress",NULL};
char* CCalculatorPage::m_pszLensTypeRecFormat[]=    {"LensMfg","LensName","MfgA_Const","MfgACD","MfgSF",NULL};
char* CCalculatorPage::m_pszFullLensTypeRecFormat[]={"LensMfg","LensName","MfgA_Const","pA_Const","MfgACD", "pACD", "MfgSF", "pSF",NULL};
char* CCalculatorPage::m_pszEditNewLensTypeRecFormat[]={"LensName","LensMfg", "MfgA_Const", "MfgACD","OD1","OD2",
	"OL","LA","PR","OM","LM","PC","Ad","MfgSF","Hd","Hacd","Nt",NULL};
char* CCalculatorPage::m_pszMeasureHistoryTypeRecFormat[]={"SessionDate","InScans","ScanNumber","InScanValues","InOD_OS","InMethod","InMode","OutAL","OutACD","OutLT","OutVIT","AutoManualVCR","ScData","OutDist","SG","Av","Flt","CTh","LTh1","LTh2","RTh","AvAl","SD",NULL};
char* CCalculatorPage::m_pszCalculatorTypeRecFormat[]={"SessionDate","InScans","ScanNumber","InScanValues","InOD_OS","InMethod","InMode","OutAL","OutACD","OutLT","OutVIT","AutoManualVCR","ScData","OutDist","SG","Av","Flt","CTh","LTh1","LTh2","RTh","AvAl","SD",NULL};
struct sttypeRegistryNodes CCalculatorPage::m_arListReg[]=
{
	{"CommonSettings",NULL,NULL},
	{"Patients",m_pszPatientRecFormat,NULL},
    {"Doctors",m_pszDoctorRecFormat,NULL},
	{"LensesType",m_pszLensTypeRecFormat,NULL},
    {"Patients",m_pszFullPatientRecFormat,NULL},
    {"Doctors",m_pszFullDoctorRecFormat,NULL},
	{"LensesType",m_pszFullLensTypeRecFormat,NULL},
	{"LensesType",m_pszEditNewLensTypeRecFormat,NULL},
	{"Sessions",m_pszMeasureHistoryTypeRecFormat,NULL},
	{"Sessions",m_pszCalculatorTypeRecFormat,NULL}

};
IMPLEMENT_DYNCREATE(CCalculatorPage, CPropertyPage)

CCalculatorPage::CCalculatorPage() : CPropertyPage(CCalculatorPage::IDD)
{
	//{{AFX_DATA_INIT(CCalculatorPage)
	m_bCalculate = FALSE;
	m_strValidMessage = _T("");
	//}}AFX_DATA_INIT
	m_clrDialBack=RGB(0,0,0);
	m_clrDialFront=RGB(0,0,0);
	m_clrDialBrush=RGB(0,255,0);    
   	m_hbrDialBrush=CreateSolidBrush(m_clrDialBrush);
	m_clrButtonsBrush=RGB(255,0,0); 
	m_hbrButtonsBrush=CreateSolidBrush(m_clrButtonsBrush);
	m_clrButtonsBack=RGB(255,0,0);
	m_clrButtonsFront=RGB(255,255,255);
	m_clrStaticBrush=RGB(0,0,255); 
	m_clrStaticBack=RGB(0,0,255);
	m_clrStaticFront=RGB(255,255,255);
	m_hbrStaticBrush=CreateSolidBrush(m_clrStaticBrush);
	m_clrMsgBoxesBrush=RGB(255,0,0); 
	m_hbrMsgBoxesBrush=CreateSolidBrush(m_clrButtonsBrush);
	m_clrMsgBoxesBack=RGB(255,0,0);
	m_clrMsgBoxesFront=RGB(255,255,255);
	m_clrEditBoxesBrush=RGB(255,0,0); 
	m_hbrEditBoxesBrush=CreateSolidBrush(m_clrButtonsBrush);
	m_clrEditBoxesBack=RGB(255,0,0);
	m_clrEditBoxesFront=RGB(255,255,255);
	m_clrScrollBarsBrush=RGB(255,0,0); 
	m_hbrScrollBarsBrush=CreateSolidBrush(m_clrButtonsBrush);
	m_clrScrollBarsBack=RGB(255,0,0);
	m_clrScrollBarsFront=RGB(255,255,255);
	m_clrListBoxesBrush=RGB(255,0,0); 
	m_hbrListBoxesBrush=CreateSolidBrush(m_clrButtonsBrush);
	m_clrListBoxesBack=RGB(255,0,0);
	m_clrListBoxesFront=RGB(255,255,255);
	m_bOD=TRUE;
	m_pgd=NULL;

}

CCalculatorPage::~CCalculatorPage()
{
	if(m_pgd)
    {
		m_pgd->m_pfgrid=NULL;
		delete m_pgd;
    }
}

void CCalculatorPage::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCalculatorPage)
	DDX_Control(pDX, IDC_CALCULATE, m_btCalculate);
	DDX_Control(pDX, IDC_OD_OS_BT, m_btOD_OS);
	DDX_Control(pDX, IDC_GRIDACONST, m_gridDACONST);
	DDX_Control(pDX, IDC_GRIDAL, m_gridAL);
	DDX_Control(pDX, IDC_GRIDPATID, m_gridAPATID);
	DDX_Control(pDX, IDC_LENSTABLE, m_gridLENSTABLE);
	DDX_Check(pDX, IDC_CALCULATE, m_bCalculate);
	DDX_Text(pDX, IDC_CALC_VAL_MESSAGE, m_strValidMessage);
	DDX_Control(pDX, IDC_CALC_TABLE, m_gridCalculateTable);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CCalculatorPage, CPropertyPage)
	//{{AFX_MSG_MAP(CCalculatorPage)
	ON_WM_CTLCOLOR()
	ON_BN_CLICKED(IDC_CALCULATE, OnCalculate)
	ON_BN_CLICKED(IDC_OD_OS_BT, OnOdOsBt)
	//}}AFX_MSG_MAP
	ON_REGISTERED_MESSAGE(g_uWM_YTV_EditGrid,CalculateAll)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCalculatorPage message handlers

HBRUSH CCalculatorPage::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor) 
{
	switch(nCtlColor)
	{
		default:

			return CPropertyPage::OnCtlColor(pDC, pWnd, nCtlColor);
			
		case CTLCOLOR_BTN: //  Button control
            SetTextColor(pDC->m_hDC,m_clrButtonsFront);
			SetBkColor(pDC->m_hDC,m_clrButtonsBack); 
            return m_hbrButtonsBrush;
						            
        case CTLCOLOR_DLG://   Dialog box
            SetTextColor(pDC->m_hDC,m_clrDialFront);
			SetBkColor(pDC->m_hDC,m_clrDialBack); 
            return m_hbrDialBrush;               
case CTLCOLOR_EDIT://   Edit control
            SetTextColor(pDC->m_hDC,m_clrEditBoxesFront);
			SetBkColor(pDC->m_hDC,m_clrEditBoxesBack);  
            return m_hbrEditBoxesBrush;
case CTLCOLOR_LISTBOX://   List-box control
            SetTextColor(pDC->m_hDC,m_clrListBoxesFront);
			SetBkColor(pDC->m_hDC,m_clrListBoxesBack);  
            return m_hbrListBoxesBrush;
case CTLCOLOR_MSGBOX://   Message box
            SetTextColor(pDC->m_hDC,m_clrMsgBoxesFront);
			SetBkColor(pDC->m_hDC,m_clrMsgBoxesBack); 
			return m_hbrMsgBoxesBrush;
case CTLCOLOR_SCROLLBAR://   Scroll-bar control
            SetTextColor(pDC->m_hDC,m_clrScrollBarsFront);
			SetBkColor(pDC->m_hDC,m_clrScrollBarsBack);  
            return m_hbrScrollBarsBrush;
case CTLCOLOR_STATIC://   Static control 
            SetTextColor(pDC->m_hDC,m_clrStaticFront); 
            SetBkColor(pDC->m_hDC,m_clrStaticBack); 
            return m_hbrStaticBrush;
	}
	
	// TODO: Return a different brush if the default is not desired
	return CPropertyPage::OnCtlColor(pDC, pWnd, nCtlColor);

}

BOOL CCalculatorPage::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	
	// TODO: Add extra initialization here
	m_pgd=new YtvEditGridDial;
	m_pgd->m_hw=m_hWnd;
	m_pgd->m_hwc=m_btCalculate.m_hWnd;
    m_pgd->Create(m_hWnd);
	m_pgd->m_pgridAL=&m_gridAL;
    m_pgd->m_pgridAC=&m_gridDACONST;
    m_pgd->m_pfgrid=NULL;
	m_gridDACONST.SetRows(4);
	m_gridAL.SetRows(4);
	m_gridAPATID.SetRows(3);
	m_gridDACONST.SetCols(2);
	m_gridAL.SetCols(3);
	m_gridAPATID.SetCols(2);
	m_gridDACONST.SetFixedRows(0);
	m_gridAL.SetFixedRows(0);
	m_gridAPATID.SetFixedRows(0);
	m_gridDACONST.SetColWidth(0,850);
	m_gridAL.SetColWidth(0,950);;
	m_gridAPATID.SetColWidth(0,1330);
	m_gridDACONST.SetColWidth(1,1050);
	m_gridAL.SetColWidth(1,980);;
	m_gridAPATID.SetColWidth(1,3500);
	m_gridAL.SetColWidth(2,420);
	m_gridDACONST.SetTextMatrix(0, 0, "A-Const");
	m_gridAL.SetTextMatrix(0, 0, "AL");
	m_gridAL.SetTextMatrix(0, 1, ".00");
	m_gridAL.SetTextMatrix(0, 2, "mm");
	m_gridAPATID.SetTextMatrix(0, 0, "Pat. ID");

	m_gridDACONST.SetTextMatrix(1, 0, "ACD");
	m_gridAL.SetTextMatrix(1, 2, "D");
	m_gridAL.SetTextMatrix(1, 0, "K1-Value");
	m_gridAPATID.SetTextMatrix(1, 0, "Patient Name");
	m_gridDACONST.SetTextMatrix(2, 0, "SF");
	m_gridAL.SetTextMatrix(2, 0, "K2-Value");
	m_gridAL.SetTextMatrix(2, 2, "D");
	m_gridAPATID.SetTextMatrix(2, 0, "Doctor Name");
    m_gridDACONST.SetTextMatrix(3, 0, "Rx");
	m_gridAL.SetTextMatrix(3, 0, "K-Value");
	m_gridAL.SetTextMatrix(3, 2, "D");
////////////////////////////////////////////////////////
	m_gridLENSTABLE.SetRows(6);
	m_gridLENSTABLE.SetCols(8);
	m_gridLENSTABLE.SetFixedCols(0);
	m_gridLENSTABLE.SetFixedRows(1);
	m_gridLENSTABLE.SetTextMatrix(0, 0, "Lens Name");   
    m_gridLENSTABLE.SetTextMatrix(0, 1, "Lens Mfg");
	m_gridLENSTABLE.SetTextMatrix(0, 2, "Mfg ACD");
	m_gridLENSTABLE.SetTextMatrix(0, 3, "METHOD1 ACD");
	m_gridLENSTABLE.SetTextMatrix(0, 4, "Mfg A-Const");
    m_gridLENSTABLE.SetTextMatrix(0, 5, "p A-Const");
	m_gridLENSTABLE.SetTextMatrix(0, 6, "Mfg SF");
	m_gridLENSTABLE.SetTextMatrix(0, 7, "p SF");
	m_gridLENSTABLE.SetColWidth(0,1000);
	m_gridLENSTABLE.SetColWidth(1,1000);
	m_gridLENSTABLE.SetColWidth(2,1000);
	m_gridLENSTABLE.SetColWidth(3,1000);
	m_gridLENSTABLE.SetColWidth(4,1000);
	m_gridLENSTABLE.SetColWidth(5,1000);
	m_gridLENSTABLE.SetColWidth(6,1000);
	m_gridLENSTABLE.SetColWidth(7,1000);
   ///////////////////////////////////////////
	m_nCurrentIOLTableRowStart=1;
	m_enCurrentIOLPowerType=m_enPowerTypeUndefined;
	m_nMfgNumRows=9;
	m_nMfgNumCols=2;
	m_nCalcLastFiledRow=0;
	int a,i,j,rest;
	a = 6;//groups
	m_gridCalculateTable.SetMergeCells(1);
	m_gridCalculateTable.SetRows(m_nMfgNumRows * a+1);
	m_gridCalculateTable.SetCols(7);	
    m_gridCalculateTable.SetFixedCols(0);
    m_gridCalculateTable.SetTextMatrix(0, 1, "                        METHOD1");
	m_gridCalculateTable.SetTextMatrix(0, 2, "                        METHOD1");
    m_gridCalculateTable.SetMergeRow(0, TRUE);
    m_gridCalculateTable.SetTextMatrix(0, 3, "                         SRK/T");   
    m_gridCalculateTable.SetTextMatrix(0, 4, "                         SRK/T");
    m_gridCalculateTable.SetMergeRow(0, TRUE);
	m_gridCalculateTable.SetTextMatrix(0, 5, "                      METHOD0");
	m_gridCalculateTable.SetTextMatrix(0, 6, "                      METHOD0");
	m_gridCalculateTable.SetColWidth(0,1500);
	m_gridCalculateTable.SetColWidth(1,1500);
	m_gridCalculateTable.SetColWidth(2,1500);
	m_gridCalculateTable.SetColWidth(3,1500);
    m_gridCalculateTable.SetColWidth(4,1500);
	m_gridCalculateTable.SetColWidth(5,1500);
	m_gridCalculateTable.SetColWidth(6,1500);
	COLORREF textcol=RGB(0,0,0),curcol,tablcol[4];
	tablcol[0]=RGB(0,255,255);
	tablcol[1]=RGB(200,0,255);
	tablcol[2]=RGB(127,0,255);
	tablcol[3]=RGB(0,255,0);
	CString Spaces=" ";
	for(j=0;j<6;j+=2)
	   for(i=m_gridCalculateTable.GetRows()-1;i>=0;i--)
	   {
			m_gridCalculateTable.SetRow(i);
            rest=i%m_nMfgNumRows;
			if(rest==6)
				curcol=tablcol[3];
			else
				curcol=tablcol[j/2];
            m_gridCalculateTable.SetCol(1+j);
            m_gridCalculateTable.SetCellBackColor(curcol);
			m_gridCalculateTable.SetCellForeColor(textcol);
			m_gridCalculateTable.SetCol(2+j);
			m_gridCalculateTable.SetCellBackColor(curcol);
            m_gridCalculateTable.SetCellForeColor(textcol);
			if(rest==0)
				Spaces+=" ";
             m_gridCalculateTable.SetTextMatrix(i, 0, Spaces);
		}
	   	m_gridCalculateTable.SetTextMatrix(0, 0, "            Mfg");
    m_gridCalculateTable.SetMergeCol(0, TRUE);
	for(i=0; i<a; i++)
    {
		for(j=0;j<6;j+=2)//3 methods 2 col for each method
        {
			m_gridCalculateTable.SetTextMatrix(1+i*m_nMfgNumRows, 1+j, "Emmitropia");
            m_gridCalculateTable.SetTextMatrix(2+i*m_nMfgNumRows, 1+j, "IOL");
		    m_gridCalculateTable.SetTextMatrix(2+i*m_nMfgNumRows, 2+j, "Refraction");
        }
	}
    m_gridCalculateTable.SetTextMatrix(1,0,"");
///////////////////////////////////////////////
//	m_imlImList.Create(16, 16, ILC_MASK, 2, 2);
//	m_imlImList.Add(AfxGetApp()->LoadIcon(IDR_MAINFRAME));
//    m_imlImList.Add(AfxGetApp()->LoadIcon(IDR_YTVULTTYPE));	
	CRect rect;
/*    m_listgridLens.GetWindowRect(&rect);  
	m_listgridLens.InsertColumn(0, "Lens Name", LVCFMT_LEFT,
		rect.Width() * 1/5, 0);
	m_listgridLens.InsertColumn(1,"Lens Mfg", LVCFMT_LEFT,
		rect.Width() * 2/5, 1);
	m_listgridLens.InsertColumn(2, "Mfg A-Const", LVCFMT_LEFT,
		rect.Width() * 3/5, 2);
	m_listgridLens.InsertColumn(3, "Mfg ACD", LVCFMT_LEFT,
		rect.Width() * 4/5, 3);*/
	m_gridDACONST.SetTextMatrix(0, 1, "");
	m_gridDACONST.SetTextMatrix(1, 1, "");
	m_gridDACONST.SetTextMatrix(2, 1, "");
	m_gridDACONST.SetTextMatrix(3, 1, "");
	g_bCalculatePageInited=TRUE;
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

int CCalculatorPage::ReadRegDB()
{
	m_szPatient_Id=g_szPatientId; 
    if(m_szPatient_Id.IsEmpty())
	   return 0;
    m_enTypeRegNode=encFullPatientTypeRec;
	YtvSetAdditionalRegNode(m_arListReg[m_enTypeRegNode].Node);
   	m_gridAPATID.SetTextMatrix(0, 1, g_szPatientId);//id 
	int j;
	CString Temp0,Temp1;
	char *pf;
    if(m_arListReg[m_enTypeRegNode].Format==NULL)
		return 0;  
    pf=m_arListReg[m_enTypeRegNode].Format[2];
	if(pf==NULL)
		return 0;
	UpdateData();
	m_arListReg[encFullPatientTypeRec].Data=new CString[29];
	for(j=0;;j++)
    {
           pf=m_arListReg[m_enTypeRegNode].Format[j];
		   if(pf==NULL)
			   break;
		   m_arListReg[m_enTypeRegNode].Data[j]=YtvGetProfileString(m_szPatient_Id,pf,"",1); 		 
    }   
	m_szFirstname=m_arListReg[encFullPatientTypeRec].Data[1];
	m_szLastname=m_arListReg[encFullPatientTypeRec].Data[2];
	Temp0=m_szFirstname+' '+m_szLastname;
	Temp0.TrimLeft();
	m_gridAPATID.SetTextMatrix(1, 1, Temp0); 
    m_szDoctorName=m_arListReg[encFullPatientTypeRec].Data[3];
	m_gridAPATID.SetTextMatrix(2, 1,m_szDoctorName);
    m_szNote=m_arListReg[encFullPatientTypeRec].Data[4];
	m_szDoctorId=m_arListReg[encFullPatientTypeRec].Data[5];
	Temp0=m_arListReg[encFullPatientTypeRec].Data[6];
	j=Temp0.Find('/');
	if(j>0)
	{
		m_szDob_mm=Temp0.Left(j);
		Temp0=Temp0.Mid(j+1);
        j=Temp0.Find('/');
	    if(j>0)
		{
           m_szDob_dd=Temp0.Left(j);
		   m_szDob_yy=Temp0.Mid(j+1);
        }
    }	
	if(m_arListReg[encFullPatientTypeRec].Data[7]=="M")
	      m_nGender=0;
    else
          m_nGender=1;
	m_szP_Address=m_arListReg[encFullPatientTypeRec].Data[8];
	m_szP_city=m_arListReg[encFullPatientTypeRec].Data[9];
    m_szP_state=m_arListReg[encFullPatientTypeRec].Data[10];
    m_szP_zip=m_arListReg[encFullPatientTypeRec].Data[11];
	m_szP_phone=m_arListReg[encFullPatientTypeRec].Data[12];
    m_szK1_value_r=m_arListReg[encFullPatientTypeRec].Data[13];
    m_szK1_value_r.TrimLeft();
    m_szK2_value_r=m_arListReg[encFullPatientTypeRec].Data[14];
	m_szK2_value_r.TrimLeft();
	m_szK_value_r=m_arListReg[encFullPatientTypeRec].Data[15];
	m_szK_value_r.TrimLeft();
	m_szK1_value_l=m_arListReg[encFullPatientTypeRec].Data[16];
	m_szK1_value_l.TrimLeft();
    m_szK2_value_l=m_arListReg[encFullPatientTypeRec].Data[17];
	m_szK2_value_l.TrimLeft();
	m_szK_value_l=m_arListReg[encFullPatientTypeRec].Data[18];	
	m_szK_value_l.TrimLeft();
	ReadRegSesStat();
	//g_strAvAlDistOD=m_arListReg[encFullPatientTypeRec].Data[19];
    //g_strAvAlDistOS=m_arListReg[encFullPatientTypeRec].Data[21];
	//g_strSDAlDistOD=m_arListReg[encFullPatientTypeRec].Data[20];
    //g_strSDAlDistOS=m_arListReg[encFullPatientTypeRec].Data[22];
	delete []m_arListReg[encFullPatientTypeRec].Data;
    m_arListReg[encFullPatientTypeRec].Data=NULL;	
	SetEyePar();    
	UpdateData(FALSE);
	m_enTypeRegNode=encFullDoctorTypeRec;
	YtvSetAdditionalRegNode(m_arListReg[m_enTypeRegNode].Node);
    m_arListReg[m_enTypeRegNode].Data=m_pszDbDoctorRec; 
    m_arListReg[m_enTypeRegNode].Data[0]=m_szDoctorId;
	m_szNoteD=YtvGetProfileString(m_arListReg[m_enTypeRegNode].Data[0],m_arListReg[m_enTypeRegNode].Format[3],"",1);
	m_szDOfficeName=YtvGetProfileString(m_arListReg[m_enTypeRegNode].Data[0],m_arListReg[m_enTypeRegNode].Format[4],"",1);
	m_szDAddress=YtvGetProfileString(m_arListReg[m_enTypeRegNode].Data[0],m_arListReg[m_enTypeRegNode].Format[5],"",1);
	
	UpdateData(FALSE);
	m_nLastSel=0;
	m_pGrid=&m_gridLENSTABLE;
	DoctorRefReadRegistryDB();   
	LensReadRegistryDB();  
	
	return 19;
}
void CCalculatorPage::SetEyePar()
{
  if(m_bOD)
  {
	m_gridAL.SetTextMatrix(1,1,m_szK1_value_r);
	m_gridAL.SetTextMatrix(2,1,m_szK2_value_r);
	m_gridAL.SetTextMatrix(3,1,m_szK_value_r);
	m_dPersonK=atof(m_szK_value_r);
  }
  else
  {
	m_gridAL.SetTextMatrix(1,1,m_szK1_value_l);
	m_gridAL.SetTextMatrix(2,1,m_szK2_value_l);
	m_gridAL.SetTextMatrix(3,1,m_szK_value_l);
	m_dPersonK=atof(m_szK_value_l);
  }
}
void CCalculatorPage::ReadRegSesStat()
{
	CString SessionStatAverages=m_szPatient_Id,Temp0;
	//char* pf; 
	SessionStatAverages+="\\";
	SessionStatAverages+=m_arListReg[encMeasureHistorySessionScansTypeRec].Node;
    SessionStatAverages+="\\";
	CTime dt=CTime::GetCurrentTime();
	CString Temp;
	Temp.Format("%d/%d/%d",dt.GetMonth(),dt.GetDay(),dt.GetYear());
	m_szTodayDate=Temp;
	Temp0=m_szTodayDate;
	Temp0.Replace('/','_');
	SessionStatAverages+=Temp0;
/*    pf=m_arListReg[encFullPatientTypeRec].Format[19];
	g_strDistOD=YtvGetProfileString(SessionStatAverages,pf,"",1);	
	pf=m_arListReg[encFullPatientTypeRec].Format[20];
    g_strDistOS=YtvGetProfileString(SessionStatAverages,pf,"",1); 	
	pf=m_arListReg[encFullPatientTypeRec].Format[21];
	g_strCatAvAlDistOD=YtvGetProfileString(SessionStatAverages,pf,"",1);
    pf=m_arListReg[encFullPatientTypeRec].Format[22];
	g_strCatSDAlDistOD=YtvGetProfileString(SessionStatAverages,pf,"",1); 
	pf=m_arListReg[encFullPatientTypeRec].Format[23];
	g_strAphAvAlDistOD=YtvGetProfileString(SessionStatAverages,pf,"",1);
	pf=m_arListReg[encFullPatientTypeRec].Format[24];
	g_strAphSDAlDistOD=YtvGetProfileString(SessionStatAverages,pf,"",1); 
	pf=m_arListReg[encFullPatientTypeRec].Format[25];
    g_strCatAvAlDistOS=YtvGetProfileString(SessionStatAverages,pf,"",1); 
	pf=m_arListReg[encFullPatientTypeRec].Format[26];
	g_strCatSDAlDistOS=YtvGetProfileString(SessionStatAverages,pf,"",1); 
	pf=m_arListReg[encFullPatientTypeRec].Format[27];
	g_strAphAvAlDistOS=YtvGetProfileString(SessionStatAverages,pf,"",1);	
	pf=m_arListReg[encFullPatientTypeRec].Format[28];
	g_strAphSDAlDistOS=YtvGetProfileString(SessionStatAverages,pf,"",1);*/	
}
int CCalculatorPage::LensReadRegistryDB()
{
	if(m_pGrid==NULL)
	     return -1;
   	int i,rows,j;
	m_nCalcLastFiledRow=1;
	m_NumbRecords=0;
	double dPersACD;
	CString Temp,Temp1;
	char* pch,*pchtemp;
	CString Subsection;
	CString Section;
    Section=m_arListReg[encLensTypeRec].Node; //lenses  
	m_enTypeRegNode=encFullLensTypeRec;
	YtvSetAdditionalRegNode(m_arListReg[m_enTypeRegNode].Node);
	m_arListReg[encLensTypeRec].Data=m_pszDbLensStyleRec;   
    m_enTypeRegNode=encLensTypeRec;
    if(m_arListReg[m_enTypeRegNode].Format==NULL)
		return m_NumbRecords;
    int numbchar=YtvGetProfileSection(m_arListReg[m_enTypeRegNode].Node,NULL,0);
	if(numbchar==0)
		return m_NumbRecords;
	pch=new char[numbchar+1];
	numbchar=YtvGetProfileSection(m_arListReg[m_enTypeRegNode].Node,pch,numbchar+1);
	if(numbchar==0)
		return m_NumbRecords;
	pchtemp=pch;
	rows=m_pGrid->GetRows();
    Section+="\\";
	//m_dPersonIOL;
	m_dPersA_Const=atof(m_gridDACONST.GetTextMatrix(0, 1));
	m_dPersACD=atof(m_gridDACONST.GetTextMatrix(1, 1));
	m_dPersSF=atof(m_gridDACONST.GetTextMatrix(2, 1));
	m_dPORef=atof(m_gridDACONST.GetTextMatrix(3, 1));
	m_dPersonAl=atof(m_gridAL.GetTextMatrix(0, 1));
	m_dPersonK=atof(m_gridAL.GetTextMatrix(3, 1));
	dPersACD=0.0;
	unsigned n=1;
	for(i=1;pchtemp[0];i++,pchtemp+=strlen(pchtemp)+1)
    {
     for(j=1;j<rows;j++)
     {
		 Temp=m_pGrid->GetTextMatrix(j,1); 
		 if(!Temp.IsEmpty() && Temp==pchtemp)
         {
			   //insert manuf lens data
			   Subsection=Section+Temp;
			   Temp=YtvGetProfileString(Subsection,m_arListReg[encLensTypeRec].Format[1],"",0); 
			   m_pGrid->SetTextMatrix(j,m_enLensName,Temp);	
		       Temp=YtvGetProfileString(Subsection,m_arListReg[encLensTypeRec].Format[2],"",0); //A-const
			   m_pGrid->SetTextMatrix(j,m_enLensMfgAC,Temp);
               Temp=m_pGrid->GetTextMatrix(j,m_enLensPsAC); 
               m_dPersA_Const=atof(Temp); 
			   Temp=YtvGetProfileString(Subsection,m_arListReg[encLensTypeRec].Format[3],"",0);//ACD 
		       m_pGrid->SetTextMatrix(j,m_enLensMfgAcd,Temp); 
               Temp=m_pGrid->GetTextMatrix(j,m_enLensPsAcd); 
               dPersACD=atof(Temp);
			   Temp=YtvGetProfileString(Subsection,m_arListReg[encLensTypeRec].Format[4],"",0); //SF
			   m_pGrid->SetTextMatrix(j,m_enLensMfgSF,Temp); 
               Temp=m_pGrid->GetTextMatrix(j,m_enLensPsSF);//sf 
			   m_dPersSF=atof(Temp);
               m_nCalcLastFiledRow++;
		 }
	 }	 
    }   
	delete []pch;   
	m_gridAL.SetRow(0);
	m_gridDACONST.SetRow(0);
	m_gridDACONST.SetRowSel(0);
	m_gridAL.SetRowSel(0);
	return m_NumbRecords;
}
int CCalculatorPage::DoctorRefReadRegistryDB()
{
  int numbselected=0,numbchar,nr,nc,i,s;
  char* pch,*pchtemp;
  m_nLastSel=0;
  if(m_pGrid==NULL)
	  return numbselected;
  if(m_arListReg[encFullDoctorTypeRec].Data==NULL)
	  return 0;
  m_enTypeRegNode=encFullDoctorTypeRec;
  YtvSetAdditionalRegNode(m_arListReg[m_enTypeRegNode].Node);  
  CString  Subsection,Section=m_arListReg[encFullDoctorTypeRec].Data[0],Temp,TempS;
  Section+='\\';
  Section+=m_arListReg[encLensTypeRec].Node; //lenses  
  numbchar=YtvGetProfileSection(Section,NULL,0,1);
  if(numbchar==0)
  {
	  return numbselected;

  }
  pch=new char[numbchar+1];
  numbchar=YtvGetProfileSection(Section,pch,numbchar+1,1);
  if(numbchar==0)
  {
	  delete []pch;
	  return numbselected;
  }
  pchtemp=pch;
  nr=m_pGrid->GetRows();
  nc=m_pGrid->GetCols();
  Section+='\\';
  int nsel=0;
  nr=m_NumbRecords+1;
  for(i=1;pchtemp[0];pchtemp+=strlen(pchtemp)+1)
  {
	   Temp=pchtemp;
	   s=Temp.Find('=');
	   if(s>=0)
	      Temp=Temp.Left(s);
	   if(Temp.IsEmpty())
		   continue;	    
		 m_nLastSel++;
		 nsel++;
       	 Subsection=Section+Temp;	
		 m_pGrid->SetTextMatrix(i,1,Temp);	
         TempS=YtvGetProfileString(Subsection,m_arListReg[encFullLensTypeRec].Format[0],"",1); 
         if(TempS==Temp)//there is something in the directory
         { 
			 //m_enLensName=0,//column 
       //m_enLensMfg=1,//column 
	   //m_enLensMfgAcd=2,//column 
	   //m_enLensPsAcd=3,//column 
	   //m_enLensMfgAC=4,//column 
	   //m_enLensPsAC=5,//column 
	   //m_enLensMfgSF=6,//column 
	   //m_enLensPsSF=7,//column 
			//m_pGrid->SetTextMatrix(i,0,Editdoctor::m_szPersSel); 
            Temp=YtvGetProfileString(Subsection,m_arListReg[encFullLensTypeRec].Format[1],"",1); 
			m_pGrid->SetTextMatrix(i,m_enLensName,Temp);	
		    Temp=YtvGetProfileString(Subsection,m_arListReg[encFullLensTypeRec].Format[3],"",1); 
			m_pGrid->SetTextMatrix(i,m_enLensPsAC,Temp);
		    Temp=YtvGetProfileString(Subsection,m_arListReg[encFullLensTypeRec].Format[2],"",1); 
			m_pGrid->SetTextMatrix(i,m_enLensMfgAC,Temp);
		    Temp=YtvGetProfileString(Subsection,m_arListReg[encFullLensTypeRec].Format[5],"",1); 
		    m_pGrid->SetTextMatrix(i,m_enLensPsAcd,Temp);
			Temp=YtvGetProfileString(Subsection,m_arListReg[encFullLensTypeRec].Format[4],"",1); 
            m_pGrid->SetTextMatrix(i,m_enLensMfgAcd,Temp); 
			Temp=YtvGetProfileString(Subsection,m_arListReg[encFullLensTypeRec].Format[7],"",1); 
		    m_pGrid->SetTextMatrix(i,m_enLensPsSF,Temp);
            Temp=YtvGetProfileString(Subsection,m_arListReg[encFullLensTypeRec].Format[6],"",1); 
		    m_pGrid->SetTextMatrix(i,m_enLensMfgSF,Temp);
         }
		 i++;
		 if(i>5)
			 break;
          
  }
  delete []pch;  
  m_gridAL.SetRow(0);
  m_gridDACONST.SetRow(0);
  m_gridAL.SetCol(0);
  m_gridDACONST.SetCol(0);
  m_gridAL.SetRowSel(0);
  m_gridDACONST.SetRowSel(0);
  UpdateData(FALSE);
  return numbselected;
}
void CCalculatorPage::ComputeMETHOD1Formulas(int BegRow, int BegCol,double AL, double KD,double ACD, double A_Const,double Rx)
{
	double em,IOL,Refr,HofACD;
	int ir,k;
	CString temp;
	        QMETHOD1Formula(&HofACD,AL,KD,ACD);
			METHOD1IOLPowerFormula(&em,AL,KD,HofACD,0.0);
			if(Rx!=0.0)
	            METHOD1IOLPowerFormula(&IOL,AL,KD,HofACD,Rx);
			else
                IOL=em;			
			temp.Format("%2.2f",em);
			temp.TrimLeft();
            m_gridCalculateTable.SetTextMatrix(BegRow,BegCol+1,temp);
		    ir=(int)(IOL+IOL+0.5);
			IOL=((double)ir)/2.0;
			if(IOL<0.0 || IOL>40.0)
			{
				m_strValidMessage="IOL is invalid (0<=IOL<=40)";
	            MessageBeep(MB_ICONQUESTION);
		        //UpdateData(FALSE);
				//return;
            }
            temp.Format("%5.1f",IOL);
			temp.TrimLeft();
			m_gridCalculateTable.SetTextMatrix(BegRow+5,BegCol,temp);
           	METHOD1RetrErrFormula(IOL,AL,KD,HofACD,&Refr);
		    temp.Format("%5.2f",Refr);
			temp.TrimLeft();
            m_gridCalculateTable.SetTextMatrix(BegRow+5,BegCol+1,temp);
            for(k=1;k<4;k++)
            {
              if(IOL+0.5*k<0.0 || IOL+0.5*k>40.0)
			  {
				m_strValidMessage="IOL is invalid (0<=IOL<=40)";
	            MessageBeep(MB_ICONQUESTION);
		        //UpdateData(FALSE);
				//return;
			  }
			  if(IOL-0.5*k<0.0 || IOL-0.5*k>40.0)
			  {
				m_strValidMessage="IOL is invalid (0<=IOL<=40)";
	            MessageBeep(MB_ICONQUESTION);
		        //UpdateData(FALSE);
				//return;
			  }
               temp.Format("%5.1f",IOL+0.5*k); 
			   temp.TrimLeft();
               m_gridCalculateTable.SetTextMatrix(BegRow+5+k,BegCol,temp);
			   METHOD1RetrErrFormula(IOL+0.5*k,AL,KD,HofACD,&Refr);//?
               temp.Format("%5.2f",Refr);
			   temp.TrimLeft();
               m_gridCalculateTable.SetTextMatrix(BegRow+5+k,BegCol+1,temp); 
               temp.Format("%5.1f",IOL-0.5*k); 
			   temp.TrimLeft();
               m_gridCalculateTable.SetTextMatrix(BegRow+5-k,BegCol,temp);
               METHOD1RetrErrFormula(IOL-0.5*k,AL,KD,HofACD,&Refr);//?
               temp.Format("%5.2f",Refr);
			   temp.TrimLeft();
               m_gridCalculateTable.SetTextMatrix(BegRow+5-k,BegCol+1,temp); 
            }
}
void CCalculatorPage::ComputeMETHOD0Formulas(int BegRow, int BegCol,double AL, double KD, double SF,double Rx)
{
	CString temp;
    double em,IOL,Refr;
	int ir,k;
	METHOD0FormulaForwardIOLSol(&em,0.0,AL,KD,SF,12);
			temp.Format("%2.2f",em);
			temp.TrimLeft();
            m_gridCalculateTable.SetTextMatrix(BegRow,BegCol+1,temp);
			if(Rx==0.0)
				IOL=em;
			else
                METHOD0FormulaForwardIOLSol(&IOL,Rx,AL,KD,SF,12);
			ir=(int)(IOL+IOL+0.5);
			IOL=((double)ir)/2.0;
			if(IOL<0.0 || IOL>40.0)
			{
				m_strValidMessage="IOL is invalid (0<=IOL<=40)";
	            MessageBeep(MB_ICONQUESTION);
		        //UpdateData(FALSE);
				//return;
			}
            temp.Format("%5.1f",IOL);
			temp.TrimLeft();
			m_gridCalculateTable.SetTextMatrix(BegRow+5,BegCol,temp);
			METHOD0FormulaForwardRefSol(IOL,&Refr,AL,KD,SF,12);
            temp.Format("%5.2f",Refr);
			temp.TrimLeft();
            m_gridCalculateTable.SetTextMatrix(BegRow+5,BegCol+1,temp); 
			for(k=1;k<4;k++)
            {
			  if(IOL+0.5*k<0.0 || IOL+0.5*k>40.0)
			  {
				m_strValidMessage="IOL is invalid (0<=IOL<=40)";
	            MessageBeep(MB_ICONQUESTION);
		        //UpdateData(FALSE);
				//return;
			  }
			  if(IOL-0.5*k<0.0 || IOL-0.5*k>40.0)
			  {
				m_strValidMessage="IOL is invalid (0<=IOL<=40)";
	            MessageBeep(MB_ICONQUESTION);
		        //UpdateData(FALSE);
				//return;
			  }
               temp.Format("%5.1f",IOL+0.5*k); 
			   temp.TrimLeft();
               m_gridCalculateTable.SetTextMatrix(BegRow+5+k,BegCol,temp);
			   METHOD0FormulaForwardRefSol(IOL+0.5*k,&Refr,AL,KD,SF,12);
               temp.Format("%5.2f",Refr);
			   temp.TrimLeft();
               m_gridCalculateTable.SetTextMatrix(BegRow+5+k,BegCol+1,temp); 
               temp.Format("%5.1f",IOL-0.5*k); 
			   temp.TrimLeft();
               m_gridCalculateTable.SetTextMatrix(BegRow+5-k,BegCol,temp);
               METHOD0FormulaForwardRefSol(IOL-0.5*k,&Refr,AL,KD,SF,12);
               temp.Format("%5.2f",Refr);
			   temp.TrimLeft();
               m_gridCalculateTable.SetTextMatrix(BegRow+5-k,BegCol+1,temp); 
            }
}
void CCalculatorPage::ComputeSrk_tFormulas(int BegRow, int BegCol,double A_Const,double AL, double K1D, double K2D,double IOLACD)
{
	        CString temp;
	        double em;
			int ii=1,ir,k;
            double SrkACD=SrkACDFromAConst(A_Const),IOL,Refr;
			Srk_tEmmetrAmetrFormulaIOL(&em,0.0,AL,K1D,K2D,SrkACD);
           	temp.Format("%2.2f",em);
			temp.TrimLeft();
            m_gridCalculateTable.SetTextMatrix(BegRow,BegCol+1,temp);
            ir=(int)(em+em+0.5);
			IOL=((double)ir)/2.0;
			if(IOL<0.0 || IOL>40.0)
			{
				m_strValidMessage="IOL is invalid (0<=IOL<=40)";
	            MessageBeep(MB_ICONQUESTION);
		        //UpdateData(FALSE);
				//return;
			}
            temp.Format("%5.1f",IOL);
			temp.TrimLeft();
			m_gridCalculateTable.SetTextMatrix(BegRow+5,BegCol,temp);
		    Srk_tEmmetrAmetrFormulaREFR(IOL,&Refr, AL,K1D, K2D,SrkACD);
			temp.Format("%5.2f",Refr);
			temp.TrimLeft();
            m_gridCalculateTable.SetTextMatrix(BegRow+5,BegCol+1,temp); 
			for(k=1;k<4;k++)
            {
			  if(IOL+0.5*k<0.0 || IOL+0.5*k>40.0)
			  {
				m_strValidMessage="IOL is invalid (0<=IOL<=40)";
	            MessageBeep(MB_ICONQUESTION);
		        //UpdateData(FALSE);
				//return;
			  }
			  if(IOL-0.5*k<0.0 || IOL-0.5*k>40.0)
			  {
				m_strValidMessage="IOL is invalid (0<=IOL<=40)";
	            MessageBeep(MB_ICONQUESTION);
		        //UpdateData(FALSE);
				//return;
			  }
               temp.Format("%5.1f",IOL+0.5*k); 
			   temp.TrimLeft();
               m_gridCalculateTable.SetTextMatrix(BegRow+5+k,BegCol,temp);
               Srk_tEmmetrAmetrFormulaREFR(IOL+0.5*k,&Refr, AL,K1D, K2D,SrkACD);
			   temp.Format("%5.2f",Refr);
			   temp.TrimLeft();
               m_gridCalculateTable.SetTextMatrix(BegRow+5+k,BegCol+1,temp); 
               temp.Format("%5.1f",IOL-0.5*k); 
			   temp.TrimLeft();
               m_gridCalculateTable.SetTextMatrix(BegRow+5-k,BegCol,temp);
               Srk_tEmmetrAmetrFormulaREFR(IOL-0.5*k,&Refr, AL,K1D, K2D,SrkACD);
			   temp.Format("%5.2f",Refr);
			   temp.TrimLeft();
               m_gridCalculateTable.SetTextMatrix(BegRow+5-k,BegCol+1,temp); 
            }/////////////////////////////////////////////////
}
void CCalculatorPage::CalculateIOLSquare(int BegRow, int BegCol,double AL, double K1D, double K2D, double KD,double ACD,double A_Const, double SF,double Rx)
{
	m_enCurrentIOLPowerType=(enum CCalculatorPage::IOLPowerTypes)BegCol;
    switch(m_enCurrentIOLPowerType)
    {
    default:

		break;
    case m_enPowerTypeUndefined:

		break;
	case m_enMETHOD1TypeColStart://column start
        ComputeMETHOD1Formulas(BegRow, BegCol,AL, KD,ACD, A_Const,Rx);
		break;
    case m_enSRKTTypeColStart://column start
        ComputeSrk_tFormulas(BegRow, BegCol, A_Const, AL, K1D, K2D,ACD);
		break;
	case m_enMETHOD0TypeColStart:
        ComputeMETHOD0Formulas(BegRow, BegCol, AL, KD, SF,Rx);
		break;
    }
    
}
void CCalculatorPage::CalculateMFG()
{
/*
	RECT m_RTgridDACONST;
	RECT m_RTgridAL;
	double	m_dPersonAl;
	double	m_dPersonIOL;
	double	m_dPersonK;
	double	m_dPORef;
    double	m_dPersACD;
	double  m_dPersSF;
	double  m_dPersA_Const;
	enum IOLPowerTypes
    {
       m_enPowerTypeUndefined=0,//column start
       m_enMETHOD1TypeColStart=1,//column start
       m_enSRKTTypeColStart=3,//column start
	   m_enMETHOD0TypeColStart=5//column start	  
    }m_enCurrentIOLPowerType; 
    enum LensParTypes
    {
       m_enLensName=0,//column 
       m_enLensMfg=1,//column 
	   m_enLensMfgAcd=2,//column 
	   m_enLensPsAcd=3,//column 
	   m_enLensMfgAC=4,//column 
	   m_enLensPsAC=5,//column 
	   m_enLensMfgSF=6,//column 
	   m_enLensPsSF=7,//column 
	   m_enUdAC=0,//row
	   m_enUdACD=1,//row
	   m_enUdSF=2,//row
	   m_enUdRx=3,//row
	   m_enUdMCalcAl=0,//row
	   m_enUdDEdK1=1,//row
	   m_enUdDEdK2=2,//row
	   m_enUdDEdKAv=3//row
    }m_enCurrentLensPar; 
	int m_nCurrentIOLTableRowStart;
	int m_nMfgNumRows;//number rows used for IOL table
	int m_nMfgNumCols;//number columns used for IOL table 
	int m_nCalcLastFiledRow;
	void CalculateMFG();
  */
	double KD,AL,IOLACD,Rx,A_Const,K1D,K2D,SF;
	int i,ii=0;
	int n=1,rows;
	CString temp,Temp,temp0,strA_C,strRx;
	//common input
	K1D=atof(m_gridAL.GetTextMatrix(m_enUdDEdK1,1));
	K2D=atof(m_gridAL.GetTextMatrix(m_enUdDEdK2,1));
	m_dPersonAl=AL=atof(m_gridAL.GetTextMatrix(m_enUdMCalcAl,1));
	m_dPersonK=KD=atof(m_gridAL.GetTextMatrix(m_enUdDEdKAv,1));
	strRx=m_gridDACONST.GetTextMatrix(m_enUdRx,1);
	m_dPORef=Rx=atof(strRx);
	rows=m_gridCalculateTable.GetRows();
	for(i=1;i<rows;i+=m_nMfgNumRows)
         m_gridCalculateTable.SetTextMatrix(i,0,"");
	//////////////////////////////////////////////////
	m_nCurrentIOLTableRowStart=1; 
	// user defined input
	strA_C=m_gridDACONST.GetTextMatrix(m_enUdAC, 1);	
	if(!strA_C.IsEmpty())
	{//compute on base of user defined values   
	  m_gridCalculateTable.SetTextMatrix(m_nCurrentIOLTableRowStart,0,"User Defined");
      A_Const=m_dPersA_Const=atof(strA_C);
	  IOLACD=m_dPersACD=atof(m_gridDACONST.GetTextMatrix(m_enUdACD, 1));
	  SF=m_dPersSF=atof(m_gridDACONST.GetTextMatrix(m_enUdSF, 1));
	  CalculateIOLSquare(m_nCurrentIOLTableRowStart, m_enMETHOD1TypeColStart,AL, K1D, K2D, KD, IOLACD, A_Const, SF,m_dPORef);
	  CalculateIOLSquare(m_nCurrentIOLTableRowStart, m_enSRKTTypeColStart,AL, K1D, K2D, KD, IOLACD, A_Const, SF,m_dPORef);
	  CalculateIOLSquare(m_nCurrentIOLTableRowStart, m_enMETHOD0TypeColStart,AL, K1D, K2D, KD, IOLACD, A_Const, SF,m_dPORef);
	  m_nCurrentIOLTableRowStart+=m_nMfgNumRows;
    }
	rows=m_gridLENSTABLE.GetRows();
	for(i=1;i<rows;i++)
	{
		temp=m_gridLENSTABLE.GetTextMatrix(i,m_enLensMfg);
		if(temp.IsEmpty())
		{
			rows=i;
			break;
        }
		if(rows<=1)
			return;
    }
    for(i=1;i<rows;i++,	m_nCurrentIOLTableRowStart+=m_nMfgNumRows)
	{
        m_gridCalculateTable.SetTextMatrix(m_nCurrentIOLTableRowStart,0,m_gridLENSTABLE.GetTextMatrix(i,m_enLensMfg));
        A_Const=m_dPersA_Const=atof(m_gridLENSTABLE.GetTextMatrix(i, m_enLensPsAC));
		if(A_Const==0.0)
              A_Const=m_dPersA_Const=atof(m_gridLENSTABLE.GetTextMatrix(i,m_enLensMfgAC));
	    IOLACD=m_dPersACD=atof(m_gridLENSTABLE.GetTextMatrix(i, m_enLensPsAcd));
		if(IOLACD==0.0)
              IOLACD=m_dPersACD=atof(m_gridLENSTABLE.GetTextMatrix(i, m_enLensMfgAcd));
	    SF=m_dPersSF=atof(m_gridLENSTABLE.GetTextMatrix(i, m_enLensPsSF));
		if(SF==0.0)
              SF=m_dPersSF=atof(m_gridLENSTABLE.GetTextMatrix(i, m_enLensMfgSF));
	   	CalculateIOLSquare(m_nCurrentIOLTableRowStart, m_enMETHOD1TypeColStart,AL, K1D, K2D, KD, IOLACD, A_Const, SF,m_dPORef);
	    CalculateIOLSquare(m_nCurrentIOLTableRowStart, m_enSRKTTypeColStart,AL, K1D, K2D, KD, IOLACD, A_Const, SF,m_dPORef);
	    CalculateIOLSquare(m_nCurrentIOLTableRowStart, m_enMETHOD0TypeColStart,AL, K1D, K2D, KD, IOLACD, A_Const, SF,m_dPORef);
	}
}

void CCalculatorPage::OnOdOsBt() 
{
	// TODO: Add your control notification handler code here
	if(m_bOD)
	{
		m_bOD=FALSE;
        m_btOD_OS.SetWindowText("OS");
    }
	else
	{
		m_bOD=TRUE;
        m_btOD_OS.SetWindowText("OD");
    }
    if(m_bOD)
	{
		if(g_nCataract==1)
		    m_gridAL.SetTextMatrix(0,1,g_strAphAvAlDistOD);
		else if(g_nCataract==0)
            m_gridAL.SetTextMatrix(0,1,g_strCatAvAlDistOD);
		else
            m_gridAL.SetTextMatrix(0,1,g_strDistOD);
    }
	else
    {
		if(g_nCataract==1)
            m_gridAL.SetTextMatrix(0,1,g_strAphAvAlDistOS);
		else  if(g_nCataract==0)
		    m_gridAL.SetTextMatrix(0,1,g_strCatAvAlDistOS);
		else
            m_gridAL.SetTextMatrix(0,1,g_strDistOS);
    }
	SetEyePar();

}

BEGIN_EVENTSINK_MAP(CCalculatorPage, CPropertyPage)
    //{{AFX_EVENTSINK_MAP(CCalculatorPage)
	ON_EVENT(CCalculatorPage, IDC_GRIDACONST, -600 /* Click */, OnClickGridaconst, VTS_NONE)
	ON_EVENT(CCalculatorPage, IDC_CALC_TABLE, -600 /* Click */, OnClickCalcTable, VTS_NONE)
	ON_EVENT(CCalculatorPage, IDC_LENSTABLE, -600 /* Click */, OnClickLenstable, VTS_NONE)
	ON_EVENT(CCalculatorPage, IDC_GRIDAL, 70 /* RowColChange */, OnRowColChangeGridal, VTS_NONE)
	ON_EVENT(CCalculatorPage, IDC_GRIDAL, 69 /* SelChange */, OnSelChangeGridal, VTS_NONE)
	ON_EVENT(CCalculatorPage, IDC_GRIDACONST, 69 /* SelChange */, OnSelChangeGridaconst, VTS_NONE)
	ON_EVENT(CCalculatorPage, IDC_GRIDACONST, 70 /* RowColChange */, OnRowColChangeGridaconst, VTS_NONE)
	ON_EVENT(CCalculatorPage, IDC_GRIDPATID, -600 /* Click */, OnClickGridpatid, VTS_NONE)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()

void CCalculatorPage::OnClickGridaconst() 
{
	// TODO: Add your control notification handler code here
	
}

void CCalculatorPage::OnClickCalcTable() 
{
	// TODO: Add your control notification handler code here
	if(m_pgd)
	{
		m_pgd->m_pfgrid=NULL;
		m_pgd->ShowWindow(SW_HIDE);
    }
}

void CCalculatorPage::OnClickLenstable() 
{
	// TODO: Add your control notification handler code here
	UpdateData();
	if(m_pgd)
	{
		m_pgd->m_pfgrid=NULL;
		m_pgd->ShowWindow(SW_HIDE);
    }
/*	int sel=m_gridLENSTABLE.GetRowSel();
	if(sel<1)
		return;
	FillGridLensSelected(sel);*/
}

BOOL CCalculatorPage::OnSetActive() 
{
	// TODO: Add your specialized code here and/or call the base class
	UpdateData();
	YtvInvalidCommandDial dlg;
	m_nCurrentIOLTableRowStart=1;
	m_enCurrentIOLPowerType=m_enPowerTypeUndefined;
	m_nMfgNumRows=9;
	m_nMfgNumCols=2;
	m_nCalcLastFiledRow=0;
	int rows=m_gridLENSTABLE.GetRows(),r;
	int cols=m_gridLENSTABLE.GetCols(),c;
	m_bOD=g_bOD;
	for(r=1;r<rows;r++)
        	for(c=0;c<cols;c++)
               m_gridLENSTABLE.SetTextMatrix(r,c,"");
	ReadRegDB();

	CString Temp;   
	if(m_pgd)
		m_pgd->ShowWindow(SW_HIDE);
	if(!m_pgd)
	{
      m_pgd=new YtvEditGridDial;
	  m_pgd->m_hw=m_hWnd;
	  m_pgd->m_hwc=m_btCalculate.m_hWnd;
      m_pgd->Create(m_hWnd);
	  m_pgd->m_pgridAL=&m_gridAL;
      m_pgd->m_pgridAC=&m_gridDACONST;
      m_pgd->ShowWindow(SW_HIDE);
    }
	if(m_bOD)
	{
		m_btOD_OS.SetWindowText("OD");
		if(g_nCataract==1)
		    m_gridAL.SetTextMatrix(0,1,g_strAphAvAlDistOD);
		else if(g_nCataract==0)
            m_gridAL.SetTextMatrix(0,1,g_strCatAvAlDistOD);
		else
            m_gridAL.SetTextMatrix(0,1,g_strDistOD);
    }
	else
    {		
		m_btOD_OS.SetWindowText("OS");
		if(g_nCataract==1)
            m_gridAL.SetTextMatrix(0,1,g_strAphAvAlDistOS);
		else if(g_nCataract==0)
		    m_gridAL.SetTextMatrix(0,1,g_strCatAvAlDistOS);
		else
            m_gridAL.SetTextMatrix(0,1,g_strDistOS);
    }
	if(g_nMETHOD1Calc==0)//call Q program
    {
	   STARTUPINFO StartupInfo;
	   PROCESS_INFORMATION ProcessInformation;
       GetStartupInfo(&StartupInfo);   // address of STARTUPINFO structure
       BOOL b=CreateProcess(
              g_lpApplicationName, // pointer to name of executable module
             NULL,//lpCommandLine,  // pointer to command line string
             NULL,  // process security attributes
             NULL,//LPSECURITY_ATTRIBUTES lpThreadAttributes,   // thread security attributes
             FALSE,//BOOL bInheritHandles,  // handle inheritance flag
             HIGH_PRIORITY_CLASS|CREATE_DEFAULT_ERROR_MODE|CREATE_NEW_PROCESS_GROUP,//DWORD dwCreationFlags, // creation flags
             NULL,//LPVOID lpEnvironment,  // pointer to new environment block
             NULL,//LPCTSTR lpCurrentDirectory,   // pointer to current directory name
             &StartupInfo,//LPSTARTUPINFO lpStartupInfo,  // pointer to STARTUPINFO
             &ProcessInformation//LPPROCESS_INFORMATION lpProcessInformation  // pointer to PROCESS_INFORMATION
            );

///////// insert call to run Hooffer calculator application here
      if(!b)
		 dlg.DoModal(); 
    }
    m_gridAL.SetRow(0);
	m_gridDACONST.SetRow(0);
	m_gridAL.SetColSel(0);
	m_gridDACONST.SetColSel(0);
	UpdateData(FALSE);
	m_bCalculate=TRUE;
	OnCalculate();
	return CPropertyPage::OnSetActive();
}
BOOL CCalculatorPage::OnKillActive() 
{
	// TOdo{: Add your specialized code here and/or call the base class
    if(m_pgd)
	{
		m_pgd->m_pfgrid=NULL;
		m_pgd->SendMessage(WM_DESTROY,0,0);
	    delete m_pgd;
		m_pgd=NULL;
    }
	return CPropertyPage::OnKillActive();
}

void CCalculatorPage::OnRowColChangeGridal() 
{
	// TODO: Add your control notification handler code here

   
}

void CCalculatorPage::OnSelChangeGridal() 
{
	// TODO: Add your control notification handler code here
	//UpdateData();
	if(!m_pgd)
		return;
	m_pgd->m_nGridId=0;
	m_gridAL.GetWindowRect(&m_RTgridAL); 
	//ScreenToClient(&m_RTgridAL);
	RECT rt;
	double K1,K2,AL;
	CString K;
	int row=m_gridAL.GetRowSel();
	int col=m_gridAL.GetColSel();
	if(col!=1)
	{
		AL=atof(m_gridAL.GetTextMatrix(0,1));
        K.Format("%6.2f",AL);
		K.TrimLeft();
        m_gridAL.SetTextMatrix(0,1,K);
        K1=atof(m_gridAL.GetTextMatrix(1,1));
		K2=atof(m_gridAL.GetTextMatrix(2,1)); 
        K.Format("%6.2f",K1);
		K.TrimLeft();
        m_gridAL.SetTextMatrix(1,1,K);
		K.Format("%6.2f",K2);
		K.TrimLeft();
        m_gridAL.SetTextMatrix(2,1,K);
		K.Format("%6.2f",(K1+K2)*0.5);
		K.TrimLeft();
        m_gridAL.SetTextMatrix(3,1,K);
		m_pgd->m_pfgrid=NULL;
		m_pgd->ShowWindow(SW_HIDE);
		m_gridAL.SetColSel(0);
		m_bCalculate=TRUE;
	    OnCalculate();
		return;
    }
	if(row==3)
    {
       	K1=atof(m_gridAL.GetTextMatrix(1,1));
		K2=atof(m_gridAL.GetTextMatrix(2,1));
		if(K1<35.0 || K2<35.0|| K1>60.0 ||K2>60.0)
		{
            m_pgd->m_pfgrid=NULL;
		    m_pgd->ShowWindow(SW_HIDE);
		    m_gridAL.SetColSel(0);
			return;
        }
        K.Format("%6.2f",(K1+K2)*0.5);
		K.TrimLeft();
        m_gridAL.SetTextMatrix(3,1,K);
		m_pgd->m_pfgrid=NULL;
		m_pgd->ShowWindow(SW_HIDE);
		m_gridAL.SetColSel(0);
		return;
    }
	else if(row==0)
    {
        K1=atof(m_gridAL.GetTextMatrix(1,1));
		K2=atof(m_gridAL.GetTextMatrix(2,1));
		if(K1<35.0 || K2<35.0|| K1>60.0 ||K2>60.0)
		{
            m_pgd->m_pfgrid=NULL;
		    m_pgd->ShowWindow(SW_HIDE);
		    m_gridAL.SetColSel(0);
			m_gridAL.SetTextMatrix(3,1,"00.0");
        }
		else
        {
           K.Format("%6.2f",(K1+K2)*0.5);
		   K.TrimLeft();
           m_gridAL.SetTextMatrix(3,1,K);
		}
    }
    int beginL=0,beginT=0;
	int i,cols,rows;
	double coefr,coefc;
	cols=m_gridAL.GetCols();
	rows=m_gridAL.GetRow();  
	m_gridAL.SetRow(row);
	for(i=0;i<cols;i++)
    {
       m_gridAL.SetCol(i);
	   beginL+=m_gridAL.GetCellWidth();
    }
    beginL+=m_gridAL.GetGridLineWidth()*4;
	beginT=m_gridAL.GetRowHeight(row);
  	coefr=(double)beginL/(double)(m_RTgridAL.right-m_RTgridAL.left+1);
	coefc=(m_RTgridAL.bottom-m_RTgridAL.top+1)/4;
    beginL=0;
	beginT=0;
	for(i=0;i<col;i++)
	{
	   m_gridAL.SetCol(i);
	   beginL+=m_gridAL.GetCellWidth();
    }
    rt.left=m_RTgridAL.left+(int)(((double)beginL)/coefr);
	rt.top=m_RTgridAL.top+(int)(coefc*(double)row)+1;
	m_gridAL.SetCol(col);
	rt.right=rt.left+(int)((double)(m_gridAL.GetColWidth(col))/coefr);
	rt.bottom=rt.top+(int)coefc;
	m_pgd->m_pfgrid=NULL;
	m_pgd->MoveWindow(&rt);
	m_pgd->m_pfgrid=&m_gridAL;
	m_pgd->m_col=col;
	m_pgd->m_row=row;
	m_pgd->ShowWindow(SW_SHOW);
	m_pgd->SetData();
	m_gridAL.SetColSel(0);
	m_pgd->m_edInp.SetFocus();
}

void CCalculatorPage::OnSelChangeGridaconst() 
{
	// TODO: Add your control notification handler code here
	if(!m_pgd)
		return;
    m_pgd->m_nGridId=1;
	m_gridDACONST.GetWindowRect(&m_RTgridDACONST);
	//ScreenToClient(&m_RTgridDACONST);
  	RECT rt;
	CString Temp,K;
	double A_C,ACD,SF,AL,K1,K2;
	int row=m_gridDACONST.GetRowSel();
	int col=m_gridDACONST.GetColSel();
	if(col!=1)
	{
		AL=atof(m_gridAL.GetTextMatrix(0,1));
        K.Format("%6.2f",AL);
		K.TrimLeft();
        m_gridAL.SetTextMatrix(0,1,K);
        K1=atof(m_gridAL.GetTextMatrix(1,1));
		K2=atof(m_gridAL.GetTextMatrix(2,1)); 
        K.Format("%6.2f",K1);
		K.TrimLeft();
        m_gridAL.SetTextMatrix(1,1,K);
		K.Format("%6.2f",K2);
		K.TrimLeft();
        m_gridAL.SetTextMatrix(2,1,K);
		K.Format("%6.2f",(K1+K2)*0.5);
		K.TrimLeft();
        m_gridAL.SetTextMatrix(3,1,K);
		m_pgd->m_pfgrid=NULL;
		m_pgd->ShowWindow(SW_HIDE);
		m_gridDACONST.SetColSel(0);
		Temp=m_gridDACONST.GetTextMatrix(0,1);
        Temp.TrimLeft();
		A_C=atof(Temp);
		if(A_C<110.0 || A_C>130.0)
        {
           Temp=m_gridDACONST.GetTextMatrix(1,1);
           Temp.TrimLeft();
		   ACD=atof(Temp);
		   if(ACD<1.0 || ACD>6.0)
           {
              m_gridDACONST.SetTextMatrix(1,1,"0.00");
              m_gridDACONST.SetTextMatrix(0,1,"000.0");
			  m_gridDACONST.SetTextMatrix(2,1,"0.00");
			  m_pgd->m_pfgrid=NULL;
		      m_pgd->ShowWindow(SW_HIDE);
			  m_gridDACONST.SetColSel(0);
			  m_bCalculate=TRUE;
	          OnCalculate();
		      return;
           }
		   else
           {
		      SF=SfFromAcd(ACD);			 
              Temp.Format("%1.2f",SF);
			  Temp.TrimLeft();
              m_gridDACONST.SetTextMatrix(2,1,Temp);
              Temp.Format("%1.2f",ACD);
			  Temp.TrimLeft();
              m_gridDACONST.SetTextMatrix(1,1,Temp);
			  A_C=AConstFromSF(SF);
              Temp.Format("%3.1f",A_C);
			  Temp.TrimLeft();
              m_gridDACONST.SetTextMatrix(0,1,Temp);
           }
        }
		else
        {
           SF=SfFromAConst(A_C);
           Temp.Format("%1.2f",SF);
		   Temp.TrimLeft();
           m_gridDACONST.SetTextMatrix(2,1,Temp);
           Temp.Format("%3.1f",A_C);
		   Temp.TrimLeft();
           m_gridDACONST.SetTextMatrix(0,1,Temp);
		   ACD=AcdFromSF(SF);
           Temp.Format("%1.2f",ACD);
		   Temp.TrimLeft();
           m_gridDACONST.SetTextMatrix(1,1,Temp);
        }
		m_bCalculate=TRUE;
		OnCalculate();
		return;
    }
	if(row==2)
    {
        Temp=m_gridDACONST.GetTextMatrix(0,1);
        Temp.TrimLeft();
		A_C=atof(Temp);
		if(A_C<110.0 || A_C>130.0)
        {
           Temp=m_gridDACONST.GetTextMatrix(1,1);
           Temp.TrimLeft();
		   ACD=atof(Temp);
		   if(ACD<1.0 || ACD>6.0)
           {
              m_gridDACONST.SetTextMatrix(1,1,"0.00");
              m_gridDACONST.SetTextMatrix(0,1,"000.0");
			  m_gridDACONST.SetTextMatrix(2,1,"0.00");
			  m_pgd->m_pfgrid=NULL;
		      m_pgd->ShowWindow(SW_HIDE);
			  m_gridDACONST.SetColSel(0);
			  m_bCalculate=TRUE;
	          OnCalculate();
		      return;
           }
		   else
           {
		      SF=SfFromAcd(ACD);			 
              Temp.Format("%1.2f",SF);
			  Temp.TrimLeft();
              m_gridDACONST.SetTextMatrix(2,1,Temp);
              Temp.Format("%1.2f",ACD);
			  Temp.TrimLeft();
              m_gridDACONST.SetTextMatrix(1,1,Temp);
			  A_C=AConstFromSF(SF);
              Temp.Format("%3.1f",A_C);
			  Temp.TrimLeft();
              m_gridDACONST.SetTextMatrix(0,1,Temp);
           }
        }
		else
        {
           SF=SfFromAConst(A_C);
           Temp.Format("%1.2f",SF);
		   Temp.TrimLeft();
           m_gridDACONST.SetTextMatrix(2,1,Temp);
           Temp.Format("%3.1f",A_C);
		   Temp.TrimLeft();
           m_gridDACONST.SetTextMatrix(0,1,Temp);
		   ACD=AcdFromSF(SF);
           Temp.Format("%1.2f",ACD);
		   Temp.TrimLeft();
           m_gridDACONST.SetTextMatrix(1,1,Temp);
        }
		m_pgd->m_pfgrid=NULL;
		m_pgd->ShowWindow(SW_HIDE);
		m_gridDACONST.SetColSel(0);
		m_bCalculate=TRUE;
	    OnCalculate();
		return;
    }
	int beginL=0,beginT=0;
	int i,cols,rows;
	double coefr,coefc;
	cols=m_gridDACONST.GetCols();
	rows=m_gridDACONST.GetRow();  
	m_gridDACONST.SetRow(row);
	for(i=0;i<cols;i++)
    {
       m_gridDACONST.SetCol(i);
	   beginL+=m_gridDACONST.GetCellWidth();
    }
    beginL+=m_gridDACONST.GetGridLineWidth()*3;
	beginT=m_gridDACONST.GetRowHeight(row);
  	coefr=(double)beginL/(double)(m_RTgridDACONST.right-m_RTgridDACONST.left+1);
	coefc=(m_RTgridDACONST.bottom-m_RTgridDACONST.top+1)/4;
    beginL=0;
	beginT=0;
	for(i=0;i<col;i++)
	{
	   m_gridDACONST.SetCol(i);
	   beginL+=m_gridDACONST.GetCellWidth();
    }
	beginL+=m_gridDACONST.GetGridLineWidth()*2;
    rt.left=m_RTgridDACONST.left+(int)((double)beginL/coefr)+1;
	//rt.left=m_RTgridDACONST.left+beginL;
	rt.top=m_RTgridDACONST.top+(int)(coefc*(double)row)+1;
	m_gridDACONST.SetCol(col);
	rt.right=rt.left+(int)((double)m_gridDACONST.GetColWidth(col)/coefr);
	//rt.right=rt.left+m_gridDACONST.GetColWidth(col);
	rt.bottom=rt.top+(int)coefc;
	m_pgd->m_pfgrid=NULL;
	m_pgd->MoveWindow(&rt);
	m_pgd->m_pfgrid=&m_gridDACONST;
	m_pgd->m_col=col;
	m_pgd->m_row=row;
	m_pgd->ShowWindow(SW_SHOW);
	m_pgd->SetData();
	m_gridDACONST.SetColSel(0);
    m_pgd->m_edInp.SetFocus();
}

void CCalculatorPage::OnRowColChangeGridaconst() 
{
	// TODO: Add your control notification handler code here
	
}


void CCalculatorPage::OnClickGridpatid() 
{
	// TODO: Add your control notification handler code here
	if(m_pgd)
	{
        m_pgd->m_pfgrid=NULL;
		m_pgd->ShowWindow(SW_HIDE);

    }
}
void CCalculatorPage::OnCalculate() 
{
	// TODO: Add your control notification handler code here
	UpdateData();
	double ACD,SF,K1,K2,K,AL,AC,Rx;
	CString Temp=m_gridDACONST.GetTextMatrix(1,1);
    Temp.TrimLeft();
	ACD=atof(Temp);
	Temp=m_gridDACONST.GetTextMatrix(0,1);
    Temp.TrimLeft();
	AC=atof(Temp);
	Temp=m_gridDACONST.GetTextMatrix(2,1);
    Temp.TrimLeft();
	SF=atof(Temp);
	Temp=m_gridDACONST.GetTextMatrix(3,1);
    Temp.TrimLeft();
	Rx=atof(Temp);
	Temp=m_gridAL.GetTextMatrix(0,1);
	Temp.TrimLeft();
    AL=atof(Temp);
	Temp=m_gridAL.GetTextMatrix(1,1);
	Temp.TrimLeft();
    K1=atof(Temp);
    Temp=m_gridAL.GetTextMatrix(2,1);
	Temp.TrimLeft();
	K2=atof(Temp); 
	Temp=m_gridAL.GetTextMatrix(3,1);
	Temp.TrimLeft();
	K=atof(Temp); 
	if(ACD!=0.0 && (ACD<1.0 || ACD>6.0))
	{
		   m_strValidMessage="ACD is invalid (1<=ACD<=6)";
	       MessageBeep(MB_ICONQUESTION);
		   UpdateData(FALSE);
		   return;
    }
	if(AC!=0.0 && (AC <110.0 ||AC >130.0))
	{
		   m_strValidMessage="A const is invalid (110<=A const<=130)";
	       MessageBeep(MB_ICONQUESTION);
		   UpdateData(FALSE);
		   return;
    }
	if(SF!=0.0 && (SF <-3.3 || SF >8.0))
    {
		   m_strValidMessage="SF is invalid (-3.3<=SF<=8.0)";
	       MessageBeep(MB_ICONQUESTION);
		   UpdateData(FALSE);
		   return;
    }
	if(Rx!=0.0 &&(Rx<-10.0 || Rx>10.0))
    {
		   m_strValidMessage="Rx is invalid (-10<=Rx<=10)";
	       MessageBeep(MB_ICONQUESTION);
		   UpdateData(FALSE);
		   return;
    }
	if(AL<15.0 || AL>40.0)
    {
		   m_strValidMessage="AL is invalid (15<=AL<=40)";
	       MessageBeep(MB_ICONQUESTION);
		   UpdateData(FALSE);
		   return;
    }
	if(K1<35.0 || K1>60.0)
     {
		   m_strValidMessage="K1 is invalid (35<=K1<=60)";
	       MessageBeep(MB_ICONQUESTION);
		   UpdateData(FALSE);
		   return;
    }
	if(K2<35.0 || K2>60.0)
    {
		   m_strValidMessage="K2 is invalid (35<=K2<=60)";
	       MessageBeep(MB_ICONQUESTION);
		   UpdateData(FALSE);
		   return;
    }
	if(K<35.0 || K>60.0)
    {
		   m_strValidMessage="K av is invalid (35<=K<=60)";
	       MessageBeep(MB_ICONQUESTION);
		   //UpdateData(FALSE);
		   //return;
    }
	m_strValidMessage.Empty();
	//if(m_bCalculate)
	CalculateMFG();  
	m_bCalculate=FALSE;
	UpdateData(FALSE);
}
LRESULT CCalculatorPage::CalculateAll(WPARAM wp,LPARAM lp)
{
   m_bCalculate=TRUE;
   OnCalculate();
   return 1;
}
