// ChildFrm.cpp : implementation of the CChildFrame class
//

#include "stdafx.h"
#include "YtvServices.h"

#include "ChildFrm.h"
#include "LeftView.h"
#include "YtvScansView.h"
#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
extern BOOL g_bDoNotMinimize;
extern BOOL g_bSetViewAllScreen;
extern BOOL g_bChangeWindowStyle;
/////////////////////////////////////////////////////////////////////////////
// CChildFrame

IMPLEMENT_DYNCREATE(CChildFrame, CMDIChildWnd)

BEGIN_MESSAGE_MAP(CChildFrame, CMDIChildWnd)
	//{{AFX_MSG_MAP(CChildFrame)
	ON_WM_SIZE()
	ON_WM_MOVE()
	ON_COMMAND(ID_YTV_NEXT_SLIDE, OnYtvNextSlide)
	ON_COMMAND(ID_YTV_PREVIOUS_SLIDE, OnYtvPreviousSlide)
	ON_COMMAND(ID_YTV_EXPAND_CURSORS, OnYtvExpandCursors)
	ON_COMMAND(ID_YTV_MOVE_LEFT_CURSORS, OnYtvMoveLeftCursors)
	ON_COMMAND(ID_YTV_MOVE_RIGHT_CURSORS, OnYtvMoveRightCursors)
	ON_COMMAND(ID_YTV_COMPRESS_CURSORS, OnYtvCompressCursors)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CChildFrame construction/destruction

CChildFrame::CChildFrame()
{
	// TODO: add member initialization code here
	
}

CChildFrame::~CChildFrame()
{
}

BOOL CChildFrame::OnCreateClient( LPCREATESTRUCT /*lpcs*/,
	CCreateContext* pContext)
{
	// create splitter window
	if (!m_wndSplitter.CreateStatic(this, 1, 2))
		return FALSE;

	if (!m_wndSplitter.CreateView(0, 0, RUNTIME_CLASS(CLeftView), CSize(0, 100), pContext) ||////100
		!m_wndSplitter.CreateView(0, 1, RUNTIME_CLASS(CYtvScansView), CSize(100, 100), pContext))
	{
		m_wndSplitter.DestroyWindow();
		return FALSE;
	}
    //ShowWindow(SW_MAXIMIZE);
	SetPos(); //YTV0
	return TRUE;
}

BOOL CChildFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs
 if(g_bChangeWindowStyle)
 {
    cs.style^=WS_OVERLAPPEDWINDOW; //YTV0
	cs.style|=WS_OVERLAPPED; //YTV0
	cs.style^=WS_THICKFRAME;  //YTV0  
	cs.x=0; //YTV0
	cs.y=0; //YTV0
 }
	if( !CMDIChildWnd::PreCreateWindow(cs) )
		return FALSE;

	return TRUE;
}



/////////////////////////////////////////////////////////////////////////////
// CChildFrame diagnostics

#ifdef _DEBUG
void CChildFrame::AssertValid() const
{
	CMDIChildWnd::AssertValid();
}

void CChildFrame::Dump(CDumpContext& dc) const
{
	CMDIChildWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CChildFrame message handlers

void CChildFrame::OnSize(UINT nType, int cx, int cy) 
{
	CMDIChildWnd::OnSize(nType, cx, cy);

	// TODO: Add your message handler code here
	SetPos(); //YTV0
}
 //YTV0
void CChildFrame::SetPos()
{
	if(!g_bSetViewAllScreen)
		return;
	CMainFrame* pmw=(CMainFrame*)AfxGetMainWnd();
	RECT rt;
	pmw->GetClientRect(&rt);
	rt.left=-GetSystemMetrics(SM_CXBORDER);
	rt.right+=rt.left;
	//rt.top-=GetSystemMetrics(SM_CYCAPTION);//-GetSystemMetrics(SM_CYFIXEDFRAME);
	rt.bottom+=rt.top+GetSystemMetrics(SM_CYCAPTION);
	::SetWindowPos(m_hWnd,HWND_TOP,rt.left,rt.top,rt.right,rt.bottom,SWP_NOCOPYBITS|SWP_SHOWWINDOW);
}
 //YTV0
void CChildFrame::OnMove(int x, int y) 
{
	CMDIChildWnd::OnMove(x, y);
	
	// TODO: Add your message handler code here
	SetPos(); //YTV0
}
void CChildFrame::OnYtvNextSlide() 
{
	// TODO: Add your command handler code here
	GetActiveView()->PostMessage(WM_COMMAND,ID_YTV_NEXT_SLIDE,0);
	//m_prpMesurePage->OnYtvNextSlide();
}

void CChildFrame::OnYtvPreviousSlide() 
{
	// TODO: Add your command handler code here
	//m_prpMesurePage->OnYtvPreviousSlide();
	GetActiveView()->PostMessage(WM_COMMAND,ID_YTV_PREVIOUS_SLIDE,0);
	
}

void CChildFrame::OnYtvExpandCursors() 
{
	// TODO: Add your command handler code here
	//m_prpMesurePage->OnYtvExpandCursors();
	GetActiveView()->PostMessage(WM_COMMAND,ID_YTV_EXPAND_CURSORS,0);

}

void CChildFrame::OnYtvMoveLeftCursors() 
{
	// TODO: Add your command handler code here
	//m_prpMesurePage->OnYtvMoveLeftCursors();
	GetActiveView()->PostMessage(WM_COMMAND,ID_YTV_MOVE_LEFT_CURSORS,0);
	
}

void CChildFrame::OnYtvMoveRightCursors() 
{
	// TODO: Add your command handler code here
	//m_prpMesurePage->OnYtvMoveRightCursors();
    GetActiveView()->PostMessage(WM_COMMAND,ID_YTV_MOVE_RIGHT_CURSORS,0);

}

void CChildFrame::OnYtvCompressCursors() 
{
	// TODO: Add your command handler code here
	//m_prpMesurePage->OnYtvCompressCursors();
	GetActiveView()->PostMessage(WM_COMMAND,ID_YTV_COMPRESS_CURSORS,0);

}

